/*
 * ExecDialog.java
 *
 * Copyright (C) 2012 Christian Mayer
 *
 * This file is part of CellXGui
 *
 */

/*
 * ExecDialog.java
 *
 * Created on Jan 25, 2012, 10:06:37 AM
 */
package cellxgui.view.dialogs;

import cellxgui.controller.CellXController;
import cellxgui.view.LogPanel;
import cellxgui.workers.CellXBatchWorker;
import cellxgui.workers.CellXCalibrationWorker;
import cellxgui.workers.CellXCommandLineWorker;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import javax.swing.JDialog;

/**
 *
 * @author Christian Mayer <chrixian.mayer@gmail.com>
 */
public class ExecDialog extends javax.swing.JDialog implements PropertyChangeListener, ActionListener {

    public final static String CANCEL_ACTION = "CANCEL";
    public final static String CLOSE_ACTION = "CLOSE";
    public final static String STDOUT = "STDOUT";
    public final static String STDERR = "STDERR";
    public final static String DONE = "DONE";
    public final static String FAILED = "FAILED";
    public final static String RUNNING = "RUNNING";
    public final static String STATUS = "STATUS";
    public final static String CANCELED = "CANCELED";
    private final LogPanel logPanel;
    private CellXCommandLineWorker worker;
    private final CellXController control;

    /** Creates new form ExecDialog */
    public ExecDialog(CellXController control, boolean modal, String title, String msg) {
        super(control.getView(), modal);
        initComponents();
        setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
        setLocationRelativeTo(null);
        this.setTitle(title);
        jLabel1.setText(msg);
        logPanel = new LogPanel();
        jScrollPane1.setViewportView(logPanel);
        jButton1.setActionCommand(CANCEL_ACTION);
        jButton1.addActionListener(this);
        this.control = control;
        pack();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jProgressBar1 = new javax.swing.JProgressBar();
        jScrollPane1 = new javax.swing.JScrollPane();
        jButton1 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jButton1.setText("Cancel");

        jLabel1.setText("Message");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, 413, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButton1)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jProgressBar1, javax.swing.GroupLayout.DEFAULT_SIZE, 509, Short.MAX_VALUE)
                .addContainerGap())
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 545, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jButton1))
                .addGap(18, 18, 18)
                .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 365, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables

    @Override
    public void propertyChange(PropertyChangeEvent evt) {
        if (evt.getPropertyName().equals(STDERR)) {
            logPanel.appendStderr(evt.getNewValue() == null ? "" : (String) evt.getNewValue());
        } else if (evt.getPropertyName().equals(STDOUT)) {
            logPanel.appendStderr(evt.getNewValue() == null ? "" : (String) evt.getNewValue());
        } else if (evt.getPropertyName().equals(DONE)) {
            firePropertyChange(DONE, null, null);
            jButton1.setText("Close");
        } else if (evt.getPropertyName().equals(FAILED)) {
            jButton1.setText("Close");
        } else if (evt.getPropertyName().equals(RUNNING)) {
            jProgressBar1.setIndeterminate(true);
        } else if (evt.getPropertyName().equals(STATUS)) {
            jProgressBar1.setStringPainted(true);
            jProgressBar1.setString(evt.getNewValue() == null ? "" : (String) evt.getNewValue());
        } else if (evt.getPropertyName().equals(CANCELED)) {
            jProgressBar1.setStringPainted(false);
            jProgressBar1.setIndeterminate(false);
            jProgressBar1.setString(evt.getNewValue() == null ? "" : (String) evt.getNewValue());
        }
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand().equals(CANCEL_ACTION)) {
            if (worker != null) {
                worker.stopStreamReaderThreads();
                worker.cancel(true);
                dispose();
            } else if (e.getActionCommand().equals(CLOSE_ACTION)) {
                setVisible(false);
            }
        }
    }

    public void executeCalibrateWorker(String[] cmd, File controlImage1, File controlImage2, boolean isSegmentation) {
        jProgressBar1.setIndeterminate(true);
        final CellXCalibrationWorker w = new CellXCalibrationWorker(cmd, controlImage1, controlImage2, isSegmentation, control, logPanel, jProgressBar1);
        w.addPropertyChangeListener(this);
        w.execute();
        this.worker = w;
        logPanel.appendStdout(">>" + getStrCmd(cmd));
        this.setVisible(true);
    }

    public void executeBatchWorker(String[] cmd) {
        jProgressBar1.setIndeterminate(true);
        final CellXBatchWorker w = new CellXBatchWorker(cmd, control, logPanel, jProgressBar1);
        w.addPropertyChangeListener(this);
        w.execute();
        this.worker = w;
        logPanel.appendStdout(">>" + getStrCmd(cmd));
        this.setVisible(true);
    }

    private static String getStrCmd(String[] cmd) {
        final StringBuilder sb = new StringBuilder();
        for (String s : cmd) {
            sb.append(s).append(" ");
        }
        return sb.toString();
    }
}
